<template lang="pug">
.events
  h1.events__title Мероприятия
  .events__categories
    .events__categories_wrapper
      EventCategory(
        v-for="item, index in categories"
        :key="index"
        :item="item"
      )
  .events__list(v-if="items.length")
    Card(
      v-for="item, index in items"
      :key="item.id"
      :item="item"
      :number="index"
      type="event"
      :numberDouble=9
    )
    Error(v-if="error.status") {{ error.msg }}
  .events__nothing(v-if="!items.length") Ничего не найдено!
</template>

<script>
import EventCategory from '@/components/parts/EventCategory.vue'
import Error from '@/components/parts/Error.vue'
import Card from '@/components/parts/Card.vue'

export default {
  name: 'Events',
  components: {
    EventCategory,
    Card,
    Error
  },
  data() {
    return {
      categories: [
        {
          class: 'all',
          id: 0,
          title: 'Показать все'
        },
        {
          class: 'social',
          id: 1,
          title: 'Социальное'
        },
        {
          class: 'science',
          id: 2,
          title: 'Естественнонаучное'
        },
        {
          class: 'paint',
          id: 3,
          title: 'Художественное'
        },
        {
          class: 'sport',
          id: 4,
          title: 'Спортивное'
        },
        {
          class: 'tech',
          id: 5,
          title: 'Техническое'
        },
      ],
      selectedType: '',
      data: [],
      error: {
        status: false,
        msg: 'Неверный логин или пароль'
      }
    }
  },
  computed: {
    items() {
      const { data, item, selectedType } = this
      return (!selectedType)
        ? data
        : data.filter(item => {return (item.event_type_id === selectedType)})
    }
  },
  watch: {
    '$route' (to, from) {
      const typesEnum = Object.freeze({"all":0, "social":1, "science":2, "paint":3, "sport":4, "tech":5})
      const type = typesEnum[to.params.type]
      this.selectedType = type
    }
  },
  created: async function() {
    try {
      const response = await this.$store.dispatch('getEvents')
      this.data = this.$store.getters.events
    } catch (e) {
      this.error.status = true
      this.error.msg = 'Ошибка'
      throw e
    }
  }
}
</script>

<style lang="stylus" scoped>
@import '~@/stylus/mixins.styl'

.events
  max-width: unset
  &__title
    font-size: 2em
    text-align: center
    margin: 15px 0 0
    color: mainColor
  &__categories
    width: 100%
    margin: 20px 0
    background: #929292
    &_wrapper
      max-width: 1200px
      margin: auto
      display: flex
      flex-direction: row
      justify-content: space-between
  &__list
    max-width: 1200px
    display: flex
    flex-wrap: wrap
    margin: auto
  &__nothing
    width: 100%
    max-width: 1200px
    margin: auto;
    background: #ddd
    border-radius: 10px
    text-align: center
    font-weight: 700
    padding: 15px
    color: #222
</style>
